//<c>   Copyright 1997-1998 by Gerry J. Danen; all rights reserved.

//<t>   Phone list of Maximus BBS users

//      Compiled with Microsoft C 8.00. Requires DANEN library to recompile.
//      Source released into the Public Domain.

#include"gd_tools.h"
#include"max.h"


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#define pgVERS_ "V2.00"
#define pgTITL_ "Phone List of Maximus BBS Users"
#define pgCOPR_ "1997"


//  --SORT definitions--
#define MAXLINES 15000
#define LONGEST_LINE 1024

void    sortError(const char *message);
void    sortInMemorySort(void);

char    FAR_MEM *s_Array[MAXLINES] ;            // Array of pointers to s_Array
int     s_Ax = 0 ;                              // s_Array[] array index
int     s_Seq = 0 ;                             // 0=no sort, 1=name, 2=number
//  --end SORT definitions--


void    sortError( const char *message )
{
    fprintf( stderr, "\n\nSORT ERROR: %s.\n\n", message );
    exit( BAD_EXIT );
}


int     sortCompare( const void *arg1, const void *arg2 )
{
    return( strcmp( *(char **)arg1, *(char **)arg2 ) );
}


void    main( int argc, char *argv[] )
{
    char        rec[LONGEST_LINE], ph[81], dph[81], nm[81],
                ifl[]="USER.BBS", ofl[]="MAXPHONE.DAT" ;
    struct _usr usr ;
    long        lof ;                           // length of user.bbs file
    int         fh ;                            // file handle
    int         u, x ;
    FILE        *report=NULPTR ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc > 1 )
    {
        if ( st_eq(argv[1], "/?") || st_eq(argv[1], "/h") || st_eq(argv[1], "/help") )
        {
            logon(1);
            fprintf( stderr, "Use /N to sort by name, /# to sort by phone number.\n" );
            exit( BAD_EXIT );
        }
        else
        if ( st_eq(argv[1], "/n") )
            s_Seq = 1 ;                         // sort, 1=name, 2=number
        else
        if ( st_eq(argv[1], "/#") )
            s_Seq = 2 ;
        else
        {
            logon(1);
            fprintf( stderr, "Invalid argument. Use /? for info.\n" );
            exit( BAD_EXIT );
        }
    }

    if ( (fh = open(ifl, O_RDONLY | O_BINARY)) == -1 )
    {
        fprintf( stderr, "\nCannot open user file!\a\n" );
        exit( 1 );
    }

    report = fl_create_or_replace_tty( report, ofl, "w", YES, YES );

    lof = filelength( fh ) / (long) sizeof(usr) ;
    u = (int) lof ;
    fprintf( stderr, "%d User%s in the Maximus user database\n",
                     u, ONE_OR_MORE(u) );

    for ( x = 0 ; x < u ; x++ )
    {
        read( fh, (char *)&usr, sizeof usr );
        strcpy( nm, usr.name );
        strcpy( ph, usr.phone );
        strcpy( dph, usr.dataphone );
        st_trim( nm );
        st_remove_spaces( ph );
        st_remove_spaces( dph );
        if ( ! strlen(dph) )
            strcpy( dph, ph );
        if ( s_Seq == 1 )
            sprintf( rec, "%-35.35s %s", nm, dph );
        else
            sprintf( rec, "%-18.18s %s", dph, nm );
        if ( s_Ax < MAXLINES )
        {
            if ( (s_Array[s_Ax++] = _strdup(rec)) == NULL )
                sortError( "Out of memory" );
        }
        else
            sortError( "Too many user records" );
    }
    close( fh );

    if ( s_Seq > 0 )                            // gotta sort...
        qsort( &s_Array, s_Ax, sizeof(s_Array[0]), sortCompare );

    for ( x = 0; x < s_Ax; x++ )                // write records
    {
        fprintf( report, "%s\n", s_Array[x] );
    }

    fcloseall();
    exit( 0 );
}
